#pragma once
#include <Windows.h>
#include <string>
#include <chrono>

namespace CFD
{
	static unsigned char lookupinv[16] = {
		0xf, 0x7, 0xb, 0x3, 0xd, 0x5, 0x9, 0x1,
		0xe, 0x6, 0xa, 0x2, 0xc, 0x4, 0x8, 0x0, };
	uint8_t reverse(uint8_t n);

	// nMilliseconds = 0 means infinite
	bool WaitForCTS(HANDLE hPort, size_t nMilliseconds = 0);
	void SendKeyDS102KnownData(HANDLE hPort, bool bCTS, size_t nSendCount, size_t nTimeBetweenSends, size_t nWaitMillisecondsAfterCTS);
	bool SendKeyDS102(HANDLE hPort, std::wstring strKeyFile, bool bCTS, std::wstring strTimer_TA, size_t nSendCount, size_t nTimeBetweenSends, size_t nWaitMillisecondsAfterCTS, std::wstring strCTSMessage = L"", size_t nMillisecondsTimeout = 0);
	bool SendKeyDS102Tempest(HANDLE hPort, std::wstring strKeyFile, size_t nSendCount, size_t nTimeBetweenSends, std::wstring strCTSMessage = L"", size_t nMillisecondsTimeout = 0);
	void SendKeyMode4KnownData(HANDLE hPort);
	void SendKeyMode4(HANDLE hPort, std::wstring strKeyFileA, std::wstring strKeyFileB);
	void SendKeyDS102SincgarsMode1(HANDLE hPort, std::wstring strKeyFileBaseName, std::wstring strKeyFileExtension, std::wstring Timer_t2A, std::wstring Timer_t2B);
	void SendKeyDS102SincgarsMode2IcomKnownData(HANDLE hPort);
	void SendKeyDS102SincgarsMode2Icom(HANDLE hPort, std::wstring strKeyFileBaseName, std::wstring strKeyFileExtension, std::wstring Timer_t2A, std::wstring Timer_t2B);
	void SendKeyDS102KempleKnownData(HANDLE hPort, bool bCTS, size_t nSendCount, size_t nTimeBetweenSends);
	void ReceiveTestKeysDS102CTS(HANDLE hPort, std::wstring strKeyFileBaseName, std::wstring strKeyFileExtension, size_t nTimeout = 32);
};

