#include <stdlib.h>
#include <stdio.h>
#include <err.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>

static int _modem_receive(const char *path)
{
    int fd, r;

    if (-1 == (fd = open(path, O_RDONLY | O_NOCTTY))) {
        perror("open");
        return -1;
    }

    if (-1 == (r = tcflush(fd, TCIFLUSH))) {
        perror("tcflush");
        goto out;
    }

    while (1) {
        char buffer[1024], *p;
        int len;

        if (-1 == (r = (int)read(fd, buffer, sizeof(buffer)))) {
            perror("read");
            goto out;
        }

        for (p = buffer, len = r; len > 0; p += r, len -= r) {
            if (-1 == (r = (int)write(1, p, len))) {
                perror("write");
                goto out;
            }
        }
    }

out:
    close(fd);
    return r;
}

int main(int argc, char *argv[])
{
    if (argc < 2)
    {
        printf("receive /dev/ttyACM0\n");
        return 0;
    }

    return _modem_receive(argv[1]);
}
